   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
  75                     ; 63 void FLASH_Unlock(FLASH_MemType_TypeDef MemType)
  75                     ; 64 {
  77                     	switch	.text
  78  0000               _FLASH_Unlock:
  82                     ; 66     assert_param(IS_MEMORY_TYPE_OK(MemType));
  84                     ; 69     if (MemType == FLASH_MEMTYPE_PROG)
  86  0000 4d            	tnz	a
  87  0001 260a          	jrne	L73
  88                     ; 71         FLASH->PUKR = FLASH_RASS_KEY1;
  90  0003 35565062      	mov	20578,#86
  91                     ; 72         FLASH->PUKR = FLASH_RASS_KEY2;
  93  0007 35ae5062      	mov	20578,#174
  95  000b 2008          	jra	L14
  96  000d               L73:
  97                     ; 78         FLASH->DUKR = FLASH_RASS_KEY2; /* Warning: keys are reversed on data memory !!! */
  99  000d 35ae5064      	mov	20580,#174
 100                     ; 79         FLASH->DUKR = FLASH_RASS_KEY1;
 102  0011 35565064      	mov	20580,#86
 103  0015               L14:
 104                     ; 82 }
 107  0015 81            	ret
 142                     ; 98 void FLASH_Lock(FLASH_MemType_TypeDef MemType)
 142                     ; 99 {
 143                     	switch	.text
 144  0016               _FLASH_Lock:
 148                     ; 101     assert_param(IS_MEMORY_TYPE_OK(MemType));
 150                     ; 104     if (MemType == FLASH_MEMTYPE_PROG)
 152  0016 4d            	tnz	a
 153  0017 2606          	jrne	L16
 154                     ; 106         FLASH->IAPSR = (u8)(~FLASH_IAPSR_PUL);
 156  0019 35fd505f      	mov	20575,#253
 158  001d 2004          	jra	L36
 159  001f               L16:
 160                     ; 112         FLASH->IAPSR = (u8)(~FLASH_IAPSR_DUL);
 162  001f 35f7505f      	mov	20575,#247
 163  0023               L36:
 164                     ; 114 }
 167  0023 81            	ret
 199                     ; 130 void FLASH_DeInit(void)
 199                     ; 131 {
 200                     	switch	.text
 201  0024               _FLASH_DeInit:
 203  0024 88            	push	a
 204       00000001      OFST:	set	1
 207                     ; 132     u8 temp = 0;
 209                     ; 133     FLASH->CR1 = FLASH_CR1_RESET_VALUE;
 211  0025 725f505a      	clr	20570
 212                     ; 134     FLASH->CR2 = FLASH_CR2_RESET_VALUE;
 214  0029 725f505b      	clr	20571
 215                     ; 135     FLASH->NCR2 = FLASH_NCR2_RESET_VALUE;
 217  002d 35ff505c      	mov	20572,#255
 218                     ; 136     FLASH->IAPSR &= (u8)(~FLASH_IAPSR_DUL);
 220  0031 7217505f      	bres	20575,#3
 221                     ; 137     FLASH->IAPSR &= (u8)(~FLASH_IAPSR_PUL);
 223  0035 7213505f      	bres	20575,#1
 224                     ; 138     temp = FLASH->IAPSR; /* Reading of this register causes the clearing of status flags */
 226  0039 c6505f        	ld	a,20575
 227                     ; 139 }
 230  003c 84            	pop	a
 231  003d 81            	ret
 286                     ; 154 void FLASH_ITConfig(FunctionalState NewState)
 286                     ; 155 {
 287                     	switch	.text
 288  003e               _FLASH_ITConfig:
 292                     ; 156     if (NewState != DISABLE)
 294  003e 4d            	tnz	a
 295  003f 2706          	jreq	L721
 296                     ; 158         FLASH->CR1 |= FLASH_CR1_IE; /* Enables the interrupt sources */
 298  0041 7212505a      	bset	20570,#1
 300  0045 2004          	jra	L131
 301  0047               L721:
 302                     ; 162         FLASH->CR1 &= (u8)(~FLASH_CR1_IE); /* Disables the interrupt sources */
 304  0047 7213505a      	bres	20570,#1
 305  004b               L131:
 306                     ; 164 }
 309  004b 81            	ret
 358                     ; 184 void FLASH_EraseBlock(u16 BlockNum, FLASH_MemType_TypeDef MemType)
 358                     ; 185 {
 359                     	switch	.text
 360  004c               _FLASH_EraseBlock:
 362  004c 89            	pushw	x
 363  004d 5204          	subw	sp,#4
 364       00000004      OFST:	set	4
 367                     ; 186     u32 StartAddress = 0;
 369                     ; 189     assert_param(IS_MEMORY_TYPE_OK(MemType));
 371                     ; 190     if (MemType == FLASH_MEMTYPE_PROG)
 373  004f 0d09          	tnz	(OFST+5,sp)
 374  0051 260c          	jrne	L551
 375                     ; 192         assert_param(IS_FLASH_PROG_BLOCK_NUMBER_OK(BlockNum));
 377                     ; 193         StartAddress = FLASH_PROG_START_PHYSICAL_ADDRESS;
 379  0053 ae8000        	ldw	x,#32768
 380  0056 1f03          	ldw	(OFST-1,sp),x
 381  0058 ae0000        	ldw	x,#0
 382  005b 1f01          	ldw	(OFST-3,sp),x
 384  005d 200a          	jra	L751
 385  005f               L551:
 386                     ; 197         assert_param(IS_FLASH_DATA_BLOCK_NUMBER_OK(BlockNum));
 388                     ; 198         StartAddress = FLASH_DATA_START_PHYSICAL_ADDRESS;
 390  005f ae4000        	ldw	x,#16384
 391  0062 1f03          	ldw	(OFST-1,sp),x
 392  0064 ae0000        	ldw	x,#0
 393  0067 1f01          	ldw	(OFST-3,sp),x
 394  0069               L751:
 395                     ; 202     StartAddress = StartAddress + ((u32)BlockNum * FLASH_BLOCK_SIZE);
 397  0069 1e05          	ldw	x,(OFST+1,sp)
 398  006b a680          	ld	a,#128
 399  006d cd0000        	call	c_cmulx
 401  0070 96            	ldw	x,sp
 402  0071 1c0001        	addw	x,#OFST-3
 403  0074 cd0000        	call	c_lgadd
 405                     ; 205     FLASH->CR2 |= FLASH_CR2_ERASE;
 407  0077 721a505b      	bset	20571,#5
 408                     ; 206     FLASH->NCR2 &= (u8)(~FLASH_NCR2_NERASE);
 410  007b 721b505c      	bres	20572,#5
 411                     ; 209     *((@far u8*) StartAddress) = FLASH_CLEAR_BYTE;
 413  007f 7b02          	ld	a,(OFST-2,sp)
 414  0081 b700          	ld	c_x,a
 415  0083 1e03          	ldw	x,(OFST-1,sp)
 416  0085 bf01          	ldw	c_x+1,x
 417  0087 4f            	clr	a
 418  0088 92bd0000      	ldf	[c_x.e],a
 419                     ; 210     *((@far u8*) StartAddress + 1) = FLASH_CLEAR_BYTE;
 422  008c 7b02          	ld	a,(OFST-2,sp)
 423  008e b700          	ld	c_x,a
 424  0090 1e03          	ldw	x,(OFST-1,sp)
 425  0092 90ae0001      	ldw	y,#1
 426  0096 bf01          	ldw	c_x+1,x
 427  0098 93            	ldw	x,y
 428  0099 4f            	clr	a
 429  009a 92a70000      	ldf	([c_x.e],x),a
 430                     ; 211     *((@far u8*) StartAddress + 2) = FLASH_CLEAR_BYTE;
 433  009e 7b02          	ld	a,(OFST-2,sp)
 434  00a0 b700          	ld	c_x,a
 435  00a2 1e03          	ldw	x,(OFST-1,sp)
 436  00a4 90ae0002      	ldw	y,#2
 437  00a8 bf01          	ldw	c_x+1,x
 438  00aa 93            	ldw	x,y
 439  00ab 4f            	clr	a
 440  00ac 92a70000      	ldf	([c_x.e],x),a
 441                     ; 212     *((@far u8*) StartAddress + 3) = FLASH_CLEAR_BYTE;
 444  00b0 7b02          	ld	a,(OFST-2,sp)
 445  00b2 b700          	ld	c_x,a
 446  00b4 1e03          	ldw	x,(OFST-1,sp)
 447  00b6 90ae0003      	ldw	y,#3
 448  00ba bf01          	ldw	c_x+1,x
 449  00bc 93            	ldw	x,y
 450  00bd 4f            	clr	a
 451  00be 92a70000      	ldf	([c_x.e],x),a
 452                     ; 219 }
 456  00c2 5b06          	addw	sp,#6
 457  00c4 81            	ret
 489                     ; 238 void FLASH_EraseByte(u32 Address)
 489                     ; 239 {
 490                     	switch	.text
 491  00c5               _FLASH_EraseByte:
 493       00000000      OFST:	set	0
 496                     ; 241     assert_param(IS_FLASH_ADDRESS_OK(Address));
 498                     ; 244     *((@far u8*) Address) = FLASH_CLEAR_BYTE; /* Erase byte */
 500  00c5 7b04          	ld	a,(OFST+4,sp)
 501  00c7 b700          	ld	c_x,a
 502  00c9 1e05          	ldw	x,(OFST+5,sp)
 503  00cb bf01          	ldw	c_x+1,x
 504  00cd 4f            	clr	a
 505  00ce 92bd0000      	ldf	[c_x.e],a
 506                     ; 248 }
 510  00d2 81            	ret
 544                     ; 267 void FLASH_EraseOptionByte(u32 Address)
 544                     ; 268 {
 545                     	switch	.text
 546  00d3               _FLASH_EraseOptionByte:
 548       00000000      OFST:	set	0
 551                     ; 270     assert_param(IS_OPTION_BYTE_ADDRESS_OK(Address));
 553                     ; 273     FLASH->CR2 |= FLASH_CR2_OPT;
 555  00d3 721e505b      	bset	20571,#7
 556                     ; 274     FLASH->NCR2 &= (u8)(~FLASH_NCR2_NOPT);
 558  00d7 721f505c      	bres	20572,#7
 559                     ; 278     *((@far u8*)Address) = FLASH_CLEAR_BYTE;
 561  00db 7b04          	ld	a,(OFST+4,sp)
 562  00dd b700          	ld	c_x,a
 563  00df 1e05          	ldw	x,(OFST+5,sp)
 564  00e1 bf01          	ldw	c_x+1,x
 565  00e3 4f            	clr	a
 566  00e4 92bd0000      	ldf	[c_x.e],a
 567                     ; 279     *((@far u8*)(Address + 1 )) = FLASH_SET_BYTE;
 570  00e8 96            	ldw	x,sp
 571  00e9 1c0003        	addw	x,#OFST+3
 572  00ec cd0000        	call	c_ltor
 574  00ef a601          	ld	a,#1
 575  00f1 cd0000        	call	c_ladc
 577  00f4 450100        	mov	c_x,c_lreg+1
 578  00f7 be02          	ldw	x,c_lreg+2
 579  00f9 bf01          	ldw	c_x+1,x
 580  00fb a6ff          	ld	a,#255
 581  00fd 92bd0000      	ldf	[c_x.e],a
 582                     ; 285     FLASH_WaitForLastOperation(FLASH_MEMTYPE_DATA);
 585  0101 a601          	ld	a,#1
 586  0103 cd02eb        	call	_FLASH_WaitForLastOperation
 588                     ; 288     FLASH->CR2 &= (u8)(~FLASH_CR2_OPT);
 590  0106 721f505b      	bres	20571,#7
 591                     ; 289     FLASH->NCR2 |= FLASH_NCR2_NOPT;
 593  010a 721e505c      	bset	20572,#7
 594                     ; 290 }
 597  010e 81            	ret
 695                     ; 318 void FLASH_ProgramBlock(u16 BlockNum, FLASH_MemType_TypeDef MemType, FLASH_ProgramMode_TypeDef ProgMode, u8 *Buffer)
 695                     ; 319 {
 696                     	switch	.text
 697  010f               _FLASH_ProgramBlock:
 699  010f 89            	pushw	x
 700  0110 5206          	subw	sp,#6
 701       00000006      OFST:	set	6
 704                     ; 320     u16 Count = 0;
 706                     ; 321     u32 StartAddress = 0;
 708                     ; 324     assert_param(IS_MEMORY_TYPE_OK(MemType));
 710                     ; 325     assert_param(IS_FLASH_PROGRAM_MODE_OK(ProgMode));
 712                     ; 326     if (MemType == FLASH_MEMTYPE_PROG)
 714  0112 0d0b          	tnz	(OFST+5,sp)
 715  0114 260c          	jrne	L552
 716                     ; 328         assert_param(IS_FLASH_PROG_BLOCK_NUMBER_OK(BlockNum));
 718                     ; 329         StartAddress = FLASH_PROG_START_PHYSICAL_ADDRESS;
 720  0116 ae8000        	ldw	x,#32768
 721  0119 1f03          	ldw	(OFST-3,sp),x
 722  011b ae0000        	ldw	x,#0
 723  011e 1f01          	ldw	(OFST-5,sp),x
 725  0120 200a          	jra	L752
 726  0122               L552:
 727                     ; 333         assert_param(IS_FLASH_DATA_BLOCK_NUMBER_OK(BlockNum));
 729                     ; 334         StartAddress = FLASH_DATA_START_PHYSICAL_ADDRESS;
 731  0122 ae4000        	ldw	x,#16384
 732  0125 1f03          	ldw	(OFST-3,sp),x
 733  0127 ae0000        	ldw	x,#0
 734  012a 1f01          	ldw	(OFST-5,sp),x
 735  012c               L752:
 736                     ; 338     StartAddress = StartAddress + ((u32)BlockNum * FLASH_BLOCK_SIZE);
 738  012c 1e07          	ldw	x,(OFST+1,sp)
 739  012e a680          	ld	a,#128
 740  0130 cd0000        	call	c_cmulx
 742  0133 96            	ldw	x,sp
 743  0134 1c0001        	addw	x,#OFST-5
 744  0137 cd0000        	call	c_lgadd
 746                     ; 341     if (ProgMode == FLASH_PROGRAMMODE_STANDARD)
 748  013a 0d0c          	tnz	(OFST+6,sp)
 749  013c 260a          	jrne	L162
 750                     ; 344         FLASH->CR2 |= FLASH_CR2_PRG;
 752  013e 7210505b      	bset	20571,#0
 753                     ; 345         FLASH->NCR2 &= (u8)(~FLASH_NCR2_NPRG);
 755  0142 7211505c      	bres	20572,#0
 757  0146 2008          	jra	L362
 758  0148               L162:
 759                     ; 350         FLASH->CR2 |= FLASH_CR2_FPRG;
 761  0148 7218505b      	bset	20571,#4
 762                     ; 351         FLASH->NCR2 &= (u8)(~FLASH_NCR2_NFPRG);
 764  014c 7219505c      	bres	20572,#4
 765  0150               L362:
 766                     ; 355     for (Count = 0; Count < FLASH_BLOCK_SIZE; Count++)
 768  0150 5f            	clrw	x
 769  0151 1f05          	ldw	(OFST-1,sp),x
 770  0153               L562:
 771                     ; 357         *((u8*)StartAddress + Count) = ((u8)(Buffer[Count]));
 773  0153 1e0d          	ldw	x,(OFST+7,sp)
 774  0155 72fb05        	addw	x,(OFST-1,sp)
 775  0158 f6            	ld	a,(x)
 776  0159 1e03          	ldw	x,(OFST-3,sp)
 777  015b 72fb05        	addw	x,(OFST-1,sp)
 778  015e f7            	ld	(x),a
 779                     ; 355     for (Count = 0; Count < FLASH_BLOCK_SIZE; Count++)
 781  015f 1e05          	ldw	x,(OFST-1,sp)
 782  0161 1c0001        	addw	x,#1
 783  0164 1f05          	ldw	(OFST-1,sp),x
 786  0166 1e05          	ldw	x,(OFST-1,sp)
 787  0168 a30080        	cpw	x,#128
 788  016b 25e6          	jrult	L562
 789                     ; 359 }
 792  016d 5b08          	addw	sp,#8
 793  016f 81            	ret
 832                     ; 381 void FLASH_ProgramByte(u32 Address, u8 Data)
 832                     ; 382 {
 833                     	switch	.text
 834  0170               _FLASH_ProgramByte:
 836       00000000      OFST:	set	0
 839                     ; 384     assert_param(IS_FLASH_ADDRESS_OK(Address));
 841                     ; 387     *((@far u8*) Address) = Data;
 843  0170 7b07          	ld	a,(OFST+7,sp)
 844  0172 88            	push	a
 845  0173 7b05          	ld	a,(OFST+5,sp)
 846  0175 b700          	ld	c_x,a
 847  0177 1e06          	ldw	x,(OFST+6,sp)
 848  0179 84            	pop	a
 849  017a bf01          	ldw	c_x+1,x
 850  017c 92bd0000      	ldf	[c_x.e],a
 851                     ; 391 }
 854  0180 81            	ret
 895                     ; 411 void FLASH_ProgramOptionByte(u32 Address, u8 Data)
 895                     ; 412 {
 896                     	switch	.text
 897  0181               _FLASH_ProgramOptionByte:
 899       00000000      OFST:	set	0
 902                     ; 414     assert_param(IS_OPTION_BYTE_ADDRESS_OK(Address));
 904                     ; 417     FLASH->CR2 |= FLASH_CR2_OPT;
 906  0181 721e505b      	bset	20571,#7
 907                     ; 418     FLASH->NCR2 &= (u8)(~FLASH_NCR2_NOPT);
 909  0185 721f505c      	bres	20572,#7
 910                     ; 422     *((@far u8*)Address) = Data;
 912  0189 7b07          	ld	a,(OFST+7,sp)
 913  018b 88            	push	a
 914  018c 7b05          	ld	a,(OFST+5,sp)
 915  018e b700          	ld	c_x,a
 916  0190 1e06          	ldw	x,(OFST+6,sp)
 917  0192 84            	pop	a
 918  0193 bf01          	ldw	c_x+1,x
 919  0195 92bd0000      	ldf	[c_x.e],a
 920                     ; 423     *((@far u8*)(Address + 1)) = (u8)(~Data);
 922  0199 96            	ldw	x,sp
 923  019a 1c0003        	addw	x,#OFST+3
 924  019d cd0000        	call	c_ltor
 926  01a0 a601          	ld	a,#1
 927  01a2 cd0000        	call	c_ladc
 929  01a5 450100        	mov	c_x,c_lreg+1
 930  01a8 be02          	ldw	x,c_lreg+2
 931  01aa 7b07          	ld	a,(OFST+7,sp)
 932  01ac 43            	cpl	a
 933  01ad bf01          	ldw	c_x+1,x
 934  01af 92bd0000      	ldf	[c_x.e],a
 935                     ; 429     FLASH_WaitForLastOperation(FLASH_MEMTYPE_DATA);
 937  01b3 a601          	ld	a,#1
 938  01b5 cd02eb        	call	_FLASH_WaitForLastOperation
 940                     ; 432     FLASH->CR2 &= (u8)(~FLASH_CR2_OPT);
 942  01b8 721f505b      	bres	20571,#7
 943                     ; 433     FLASH->NCR2 |= FLASH_NCR2_NOPT;
 945  01bc 721e505c      	bset	20572,#7
 946                     ; 434 }
 949  01c0 81            	ret
 988                     ; 456 void FLASH_ProgramWord(u32 Address, u32 Data)
 988                     ; 457 {
 989                     	switch	.text
 990  01c1               _FLASH_ProgramWord:
 992       00000000      OFST:	set	0
 995                     ; 459     assert_param(IS_FLASH_ADDRESS_OK(Address));
 997                     ; 462     FLASH->CR2 |= FLASH_CR2_WPRG;
 999  01c1 721c505b      	bset	20571,#6
1000                     ; 463     FLASH->NCR2 &= (u8)(~FLASH_NCR2_NWPRG);
1002  01c5 721d505c      	bres	20572,#6
1003                     ; 466     *((@far u8*)Address) = BYTE_0(Data); /* Write one byte */
1005  01c9 7b0a          	ld	a,(OFST+10,sp)
1006  01cb a4ff          	and	a,#255
1007  01cd 88            	push	a
1008  01ce 7b05          	ld	a,(OFST+5,sp)
1009  01d0 b700          	ld	c_x,a
1010  01d2 1e06          	ldw	x,(OFST+6,sp)
1011  01d4 84            	pop	a
1012  01d5 bf01          	ldw	c_x+1,x
1013  01d7 92bd0000      	ldf	[c_x.e],a
1014                     ; 467     *(((@far u8*)Address) + 1) = BYTE_1(Data); /* Write one byte */
1016  01db 7b09          	ld	a,(OFST+9,sp)
1017  01dd a4ff          	and	a,#255
1018  01df 88            	push	a
1019  01e0 7b05          	ld	a,(OFST+5,sp)
1020  01e2 b700          	ld	c_x,a
1021  01e4 1e06          	ldw	x,(OFST+6,sp)
1022  01e6 84            	pop	a
1023  01e7 90ae0001      	ldw	y,#1
1024  01eb bf01          	ldw	c_x+1,x
1025  01ed 93            	ldw	x,y
1026  01ee 92a70000      	ldf	([c_x.e],x),a
1027                     ; 468     *(((@far u8*)Address) + 2) = BYTE_2(Data); /* Write one byte */
1029  01f2 7b08          	ld	a,(OFST+8,sp)
1030  01f4 a4ff          	and	a,#255
1031  01f6 88            	push	a
1032  01f7 7b05          	ld	a,(OFST+5,sp)
1033  01f9 b700          	ld	c_x,a
1034  01fb 1e06          	ldw	x,(OFST+6,sp)
1035  01fd 84            	pop	a
1036  01fe 90ae0002      	ldw	y,#2
1037  0202 bf01          	ldw	c_x+1,x
1038  0204 93            	ldw	x,y
1039  0205 92a70000      	ldf	([c_x.e],x),a
1040                     ; 469     *(((@far u8*)Address) + 3) = BYTE_3(Data); /* Write one byte */
1042  0209 7b07          	ld	a,(OFST+7,sp)
1043  020b 88            	push	a
1044  020c 7b05          	ld	a,(OFST+5,sp)
1045  020e b700          	ld	c_x,a
1046  0210 1e06          	ldw	x,(OFST+6,sp)
1047  0212 84            	pop	a
1048  0213 90ae0003      	ldw	y,#3
1049  0217 bf01          	ldw	c_x+1,x
1050  0219 93            	ldw	x,y
1051  021a 92a70000      	ldf	([c_x.e],x),a
1052                     ; 476 }
1055  021e 81            	ret
1087                     ; 492 u8 FLASH_ReadByte(u32 Address)
1087                     ; 493 {
1088                     	switch	.text
1089  021f               _FLASH_ReadByte:
1091       00000000      OFST:	set	0
1094                     ; 495     assert_param(IS_FLASH_ADDRESS_OK(Address));
1096                     ; 498     return(*((@far u8*) Address)); /* Read byte */
1098  021f 7b04          	ld	a,(OFST+4,sp)
1099  0221 b700          	ld	c_x,a
1100  0223 1e05          	ldw	x,(OFST+5,sp)
1101  0225 bf01          	ldw	c_x+1,x
1102  0227 92bc0000      	ldf	a,[c_x.e]
1105  022b 81            	ret
1160                     ; 518 u16 FLASH_ReadOptionByte(u32 Address)
1160                     ; 519 {
1161                     	switch	.text
1162  022c               _FLASH_ReadOptionByte:
1164  022c 5204          	subw	sp,#4
1165       00000004      OFST:	set	4
1168                     ; 520     u8 value_optbyte, value_optbyte_complement = 0;
1170                     ; 521     u16 res_value = 0;
1172                     ; 524     assert_param(IS_OPTION_BYTE_ADDRESS_OK(Address));
1174                     ; 527     value_optbyte = *((@far u8*)Address); /* Read option byte */
1176  022e 7b08          	ld	a,(OFST+4,sp)
1177  0230 b700          	ld	c_x,a
1178  0232 1e09          	ldw	x,(OFST+5,sp)
1179  0234 bf01          	ldw	c_x+1,x
1180  0236 92bc0000      	ldf	a,[c_x.e]
1181  023a 6b01          	ld	(OFST-3,sp),a
1182                     ; 528     value_optbyte_complement = *(((@far u8*)Address) + 1); /* Read option byte complement*/
1184  023c 7b08          	ld	a,(OFST+4,sp)
1185  023e b700          	ld	c_x,a
1186  0240 1e09          	ldw	x,(OFST+5,sp)
1187  0242 90ae0001      	ldw	y,#1
1188  0246 bf01          	ldw	c_x+1,x
1189  0248 93            	ldw	x,y
1190  0249 92af0000      	ldf	a,([c_x.e],x)
1191  024d 6b02          	ld	(OFST-2,sp),a
1192                     ; 534     if (value_optbyte == (u8)(~value_optbyte_complement))
1194  024f 7b02          	ld	a,(OFST-2,sp)
1195  0251 43            	cpl	a
1196  0252 1101          	cp	a,(OFST-3,sp)
1197  0254 2617          	jrne	L304
1198                     ; 536         res_value = (u16)((u16)value_optbyte << 8);
1200  0256 7b01          	ld	a,(OFST-3,sp)
1201  0258 5f            	clrw	x
1202  0259 97            	ld	xl,a
1203  025a 4f            	clr	a
1204  025b 02            	rlwa	x,a
1205  025c 1f03          	ldw	(OFST-1,sp),x
1206                     ; 537         res_value = res_value | (u16)value_optbyte_complement;
1208  025e 7b02          	ld	a,(OFST-2,sp)
1209  0260 5f            	clrw	x
1210  0261 97            	ld	xl,a
1211  0262 01            	rrwa	x,a
1212  0263 1a04          	or	a,(OFST+0,sp)
1213  0265 01            	rrwa	x,a
1214  0266 1a03          	or	a,(OFST-1,sp)
1215  0268 01            	rrwa	x,a
1216  0269 1f03          	ldw	(OFST-1,sp),x
1218  026b 2005          	jra	L504
1219  026d               L304:
1220                     ; 541         res_value = FLASH_OPTIONBYTE_ERROR;
1222  026d ae5555        	ldw	x,#21845
1223  0270 1f03          	ldw	(OFST-1,sp),x
1224  0272               L504:
1225                     ; 544     return(res_value);
1227  0272 1e03          	ldw	x,(OFST-1,sp)
1230  0274 5b04          	addw	sp,#4
1231  0276 81            	ret
1305                     ; 561 void FLASH_SetLowPowerMode(FLASH_LPMode_TypeDef LPMode)
1305                     ; 562 {
1306                     	switch	.text
1307  0277               _FLASH_SetLowPowerMode:
1309  0277 88            	push	a
1310       00000000      OFST:	set	0
1313                     ; 564     assert_param(IS_FLASH_LOW_POWER_MODE_OK(LPMode));
1315                     ; 566     FLASH->CR1 &= (u8)(~(FLASH_CR1_HALT | FLASH_CR1_AHALT)); /* Clears the two bits */
1317  0278 c6505a        	ld	a,20570
1318  027b a4f3          	and	a,#243
1319  027d c7505a        	ld	20570,a
1320                     ; 567     FLASH->CR1 |= (u8)LPMode; /* Sets the new mode */
1322  0280 c6505a        	ld	a,20570
1323  0283 1a01          	or	a,(OFST+1,sp)
1324  0285 c7505a        	ld	20570,a
1325                     ; 568 }
1328  0288 84            	pop	a
1329  0289 81            	ret
1387                     ; 584 void FLASH_SetProgrammingTime(FLASH_ProgramTime_TypeDef ProgTime)
1387                     ; 585 {
1388                     	switch	.text
1389  028a               _FLASH_SetProgrammingTime:
1393                     ; 587     assert_param(IS_FLASH_PROGRAM_TIME_OK(ProgTime));
1395                     ; 589     FLASH->CR1 &= (u8)(~FLASH_CR1_FIX);
1397  028a 7211505a      	bres	20570,#0
1398                     ; 590     FLASH->CR1 |= (u8)ProgTime;
1400  028e ca505a        	or	a,20570
1401  0291 c7505a        	ld	20570,a
1402                     ; 591 }
1405  0294 81            	ret
1430                     ; 608 FLASH_LPMode_TypeDef FLASH_GetLowPowerMode(void)
1430                     ; 609 {
1431                     	switch	.text
1432  0295               _FLASH_GetLowPowerMode:
1436                     ; 610     return((FLASH_LPMode_TypeDef)(FLASH->CR1 & (FLASH_CR1_HALT | FLASH_CR1_AHALT)));
1438  0295 c6505a        	ld	a,20570
1439  0298 a40c          	and	a,#12
1442  029a 81            	ret
1467                     ; 628 FLASH_ProgramTime_TypeDef FLASH_GetProgrammingTime(void)
1467                     ; 629 {
1468                     	switch	.text
1469  029b               _FLASH_GetProgrammingTime:
1473                     ; 630     return((FLASH_ProgramTime_TypeDef)(FLASH->CR1 & FLASH_CR1_FIX));
1475  029b c6505a        	ld	a,20570
1476  029e a401          	and	a,#1
1479  02a0 81            	ret
1511                     ; 648 u32 FLASH_GetBootSize(void)
1511                     ; 649 {
1512                     	switch	.text
1513  02a1               _FLASH_GetBootSize:
1515  02a1 5204          	subw	sp,#4
1516       00000004      OFST:	set	4
1519                     ; 650     u32 temp = 0;
1521                     ; 653     temp = (u32)((u32)FLASH->FPR * (u32)512);
1523  02a3 c6505d        	ld	a,20573
1524  02a6 5f            	clrw	x
1525  02a7 97            	ld	xl,a
1526  02a8 90ae0200      	ldw	y,#512
1527  02ac cd0000        	call	c_umul
1529  02af 96            	ldw	x,sp
1530  02b0 1c0001        	addw	x,#OFST-3
1531  02b3 cd0000        	call	c_rtol
1533                     ; 656     if (FLASH->FPR == 0xFF)
1535  02b6 c6505d        	ld	a,20573
1536  02b9 a1ff          	cp	a,#255
1537  02bb 2611          	jrne	L325
1538                     ; 658         temp += 512;
1540  02bd ae0200        	ldw	x,#512
1541  02c0 bf02          	ldw	c_lreg+2,x
1542  02c2 ae0000        	ldw	x,#0
1543  02c5 bf00          	ldw	c_lreg,x
1544  02c7 96            	ldw	x,sp
1545  02c8 1c0001        	addw	x,#OFST-3
1546  02cb cd0000        	call	c_lgadd
1548  02ce               L325:
1549                     ; 662     return(temp);
1551  02ce 96            	ldw	x,sp
1552  02cf 1c0001        	addw	x,#OFST-3
1553  02d2 cd0000        	call	c_ltor
1557  02d5 5b04          	addw	sp,#4
1558  02d7 81            	ret
1667                     ; 682 FlagStatus FLASH_GetFlagStatus(FLASH_Flag_TypeDef FLASH_FLAG)
1667                     ; 683 {
1668                     	switch	.text
1669  02d8               _FLASH_GetFlagStatus:
1671  02d8 88            	push	a
1672       00000001      OFST:	set	1
1675                     ; 684     FlagStatus status = RESET;
1677                     ; 686     assert_param(IS_FLASH_FLAGS_OK(FLASH_FLAG));
1679                     ; 689     if ((FLASH->IAPSR & (u8)FLASH_FLAG) != (u8)RESET)
1681  02d9 c4505f        	and	a,20575
1682  02dc 2706          	jreq	L575
1683                     ; 691         status = SET; /* FLASH_FLAG is set */
1685  02de a601          	ld	a,#1
1686  02e0 6b01          	ld	(OFST+0,sp),a
1688  02e2 2002          	jra	L775
1689  02e4               L575:
1690                     ; 695         status = RESET; /* FLASH_FLAG is reset*/
1692  02e4 0f01          	clr	(OFST+0,sp)
1693  02e6               L775:
1694                     ; 699     return status;
1696  02e6 7b01          	ld	a,(OFST+0,sp)
1699  02e8 5b01          	addw	sp,#1
1700  02ea 81            	ret
1781                     ; 717 FLASH_Status_TypeDef FLASH_WaitForLastOperation(FLASH_MemType_TypeDef MemType)
1781                     ; 718 {
1782                     	switch	.text
1783  02eb               _FLASH_WaitForLastOperation:
1785  02eb 5205          	subw	sp,#5
1786       00000005      OFST:	set	5
1789                     ; 719     u32 timeout = 2000;
1791  02ed ae07d0        	ldw	x,#2000
1792  02f0 1f03          	ldw	(OFST-2,sp),x
1793  02f2 ae0000        	ldw	x,#0
1794  02f5 1f01          	ldw	(OFST-4,sp),x
1795                     ; 720     u8 flagstatus = 0x00;
1797  02f7 0f05          	clr	(OFST+0,sp)
1798                     ; 722     if (MemType == FLASH_MEMTYPE_PROG)
1800  02f9 4d            	tnz	a
1801  02fa 2631          	jrne	L356
1803  02fc 2010          	jra	L146
1804  02fe               L736:
1805                     ; 726             flagstatus = (u8)(FLASH->IAPSR & (FLASH_IAPSR_EOP |
1805                     ; 727                                                  FLASH_IAPSR_WR_PG_DIS));
1807  02fe c6505f        	ld	a,20575
1808  0301 a405          	and	a,#5
1809  0303 6b05          	ld	(OFST+0,sp),a
1810                     ; 728             timeout--;
1812  0305 96            	ldw	x,sp
1813  0306 1c0001        	addw	x,#OFST-4
1814  0309 a601          	ld	a,#1
1815  030b cd0000        	call	c_lgsbc
1817  030e               L146:
1818                     ; 724         while ((flagstatus == 0x00) && (timeout != 0x00))
1820  030e 0d05          	tnz	(OFST+0,sp)
1821  0310 2628          	jrne	L746
1823  0312 96            	ldw	x,sp
1824  0313 1c0001        	addw	x,#OFST-4
1825  0316 cd0000        	call	c_lzmp
1827  0319 26e3          	jrne	L736
1828  031b 201d          	jra	L746
1829  031d               L156:
1830                     ; 735             flagstatus = (u8)(FLASH->IAPSR & (FLASH_IAPSR_HVOFF |
1830                     ; 736                                                  FLASH_IAPSR_WR_PG_DIS));
1832  031d c6505f        	ld	a,20575
1833  0320 a441          	and	a,#65
1834  0322 6b05          	ld	(OFST+0,sp),a
1835                     ; 737             timeout--;
1837  0324 96            	ldw	x,sp
1838  0325 1c0001        	addw	x,#OFST-4
1839  0328 a601          	ld	a,#1
1840  032a cd0000        	call	c_lgsbc
1842  032d               L356:
1843                     ; 733         while ((flagstatus == 0x00) && (timeout != 0x00))
1845  032d 0d05          	tnz	(OFST+0,sp)
1846  032f 2609          	jrne	L746
1848  0331 96            	ldw	x,sp
1849  0332 1c0001        	addw	x,#OFST-4
1850  0335 cd0000        	call	c_lzmp
1852  0338 26e3          	jrne	L156
1853  033a               L746:
1854                     ; 740     if (timeout == 0x00 )
1856  033a 96            	ldw	x,sp
1857  033b 1c0001        	addw	x,#OFST-4
1858  033e cd0000        	call	c_lzmp
1860  0341 2604          	jrne	L166
1861                     ; 742         flagstatus = FLASH_STATUS_TIMEOUT;
1863  0343 a602          	ld	a,#2
1864  0345 6b05          	ld	(OFST+0,sp),a
1865  0347               L166:
1866                     ; 745     return((FLASH_Status_TypeDef)flagstatus);
1868  0347 7b05          	ld	a,(OFST+0,sp)
1871  0349 5b05          	addw	sp,#5
1872  034b 81            	ret
1885                     	xdef	_FLASH_WaitForLastOperation
1886                     	xdef	_FLASH_GetFlagStatus
1887                     	xdef	_FLASH_GetBootSize
1888                     	xdef	_FLASH_GetProgrammingTime
1889                     	xdef	_FLASH_GetLowPowerMode
1890                     	xdef	_FLASH_SetProgrammingTime
1891                     	xdef	_FLASH_SetLowPowerMode
1892                     	xdef	_FLASH_ReadOptionByte
1893                     	xdef	_FLASH_ReadByte
1894                     	xdef	_FLASH_ProgramWord
1895                     	xdef	_FLASH_ProgramOptionByte
1896                     	xdef	_FLASH_ProgramByte
1897                     	xdef	_FLASH_ProgramBlock
1898                     	xdef	_FLASH_EraseOptionByte
1899                     	xdef	_FLASH_EraseByte
1900                     	xdef	_FLASH_EraseBlock
1901                     	xdef	_FLASH_ITConfig
1902                     	xdef	_FLASH_DeInit
1903                     	xdef	_FLASH_Lock
1904                     	xdef	_FLASH_Unlock
1905                     	xref.b	c_lreg
1906                     	xref.b	c_x
1907                     	xref.b	c_y
1926                     	xref	c_lzmp
1927                     	xref	c_lgsbc
1928                     	xref	c_rtol
1929                     	xref	c_umul
1930                     	xref	c_ladc
1931                     	xref	c_ltor
1932                     	xref	c_lgadd
1933                     	xref	c_cmulx
1934                     	end
